function trace(type, message) {
    if(message.indexOf('[webpack-dev-server]') > -1){
        
    }else{
        window.webkit.messageHandlers['logHandler'].postMessage({type, message});
    }
}

console.log = function() {
    let r = [];
    for (let x in arguments) {
        if (typeof arguments[x] != "string") {
            arguments[x] = JSON.stringify(arguments[x]);
        }
        r.push(arguments[x])
    }
    trace("console.log", r.join(" "));
}

console.error = function() {
    let r = [];
    for (let x in arguments) {
        if (typeof arguments[x] != "string") {
            arguments[x] = JSON.stringify(arguments[x]);
        }
        r.push(arguments[x])
    }
    trace("console.error", r.join(" "));
}

window.addEventListener("error", (event) => {
    console.error(event);
});

window.ncplayer_env = ncplayer_env || "production";

console.log("ENV:", window.ncplayer_env);
console.log("DOMAIN:", navigator.userAgent)



try {
    
    if (!license_key) {
        throw new Error("NO LICENSE KEY");
    }˚
    
    let head = document.getElementsByTagName('head').item(0);
    let script = document.createElement('script');

    script.setAttribute('type', 'text/javascript');

    if(window.ncplayer_env == 'beta') {
        script.setAttribute('src', 'ncplayer.beta.js?access_key=' + license_key);
        //script.setAttribute('src', 'ncplayer.gov.beta.js?access_key=' + license_key);
    }else {
        script.setAttribute('src', 'ncplayer.npm.1.1.3.js?access_key=' + license_key);
        //script.setAttribute('src', 'ncplayer.gov.real.js?access_key=' + license_key);
    }
    head.appendChild(script);


} catch(e) {
    
    console.error(e.message);
}

let player = null;
let options = null;
let tsTimer = null;
let playInfo = [];


window.createPlayer = async () => {

    try {
        
        if(navigator.userAgent.indexOf('iPhone OS 14') > -1){
            console.log('iOS 14');
            document.querySelector('#vpe-ios-sdk').className = ' isIos14 isIos14Style';
        }else{
            document.querySelector('#vpe-ios-sdk').className = ' notIos14';
        }
            player = new ncplayer('videoNcplayer', options);
       
            //재생 이벤트
            player.on('play',(res)=>{
                clearInterval(tsTimer);
               
                tsTimer = setInterval(()=>{
                    try{
                        playInfo = res.description;
                        document.title = res.description.title;
                    }catch(e){
                        
                    }
                },1000)
                
                window.webkit.messageHandlers['playerEvent'].postMessage({name:'play',data: res});
            });

            //멈춤 이벤트
            player.on('pause',()=>{
                window.webkit.messageHandlers['playerEvent'].postMessage({name:'pause',data:null});
            });

            //재생종료 이벤트
            player.on('ended',()=>{
                window.webkit.messageHandlers['playerEvent'].postMessage({name:'ended',data:null});
            });

            //시청 이벤트
            player.on('timeupdate',(res)=>{
                window.webkit.messageHandlers['playerEvent'].postMessage({name:'timeupdate',data: res });

             });

            //다음영상으로 넘어갈때 이벤트
            player.on('nextTrack',(res)=>{
                window.webkit.messageHandlers['playerEvent'].postMessage({name:"nextTrack",data: res });
            });

            //이전영상으로 넘어갈때 이벤트
            player.on('prevTrack',(res)=>{
                window.webkit.messageHandlers['playerEvent'].postMessage({name:"prevTrack",data: res });
            });
            
            //컨트롤바 활성화 되었을시
            player.on('controlbarActive',()=>{
                window.webkit.messageHandlers['playerEvent'].postMessage({name:"controlbarActive",data:{active:true}});
            });

            //컨트롤바 비활성화 되었을시
            player.on('controlbarDeactive',()=>{
                window.webkit.messageHandlers['playerEvent'].postMessage({name:"controlbarActive",data:{active:false}});
            });
        
            player.on('fullscreen_off',()=>{
                console.log("off !!")
                window.webkit.messageHandlers['playerEvent'].postMessage({name:'fullscreen_off',data:null});
            });

            player.on('fullscreen_on',()=>{
                console.log("on !!")
                window.webkit.messageHandlers['playerEvent'].postMessage({name:'fullscreen_on',data:null});
            });

            player.on('fullscreen',(res)=>{
                console.log("fuullscreen !!")
                window.webkit.messageHandlers['playerEvent'].postMessage({name:'fullscreen',data: res });
            });
        
        
            player.on('ready',(res)=>{
                
                try{
                    playInfo = res.description;
                    document.title = res.description.title;
                }catch(e){
                    
                }
                
                if(options.aspectRatio){
                    document.querySelector('#videoNcplayer').style.aspectRatio = options.aspectRatio;
                }else{
                    document.querySelector('#videoNcplayer').style.aspectRatio = '16/9';
                }
                
                //시작시 가로를 저장해서 세로길이를 maxheight로 설정
                if(navigator.userAgent.indexOf('iPad') > -1){
                    document.querySelector('#vpe-ios-sdk').style.maxHeight = window.innerWidth+'px';
                }else{
                    
                    
                    if(navigator.userAgent.indexOf('iPhone OS 14') > -1){
                        document.querySelector('#videoNcplayer').style.height = '100%';
                        
                        
                        //videoNcplayer
                    }else{
                        document.querySelector('#videoNcplayer').style.maxHeight = window.innerWidth+'px';
                    }
                }
            
            })

    } catch(e) {
        console.error(e.message)
    }
}


// Ncplayer
window.Ncplayer = {
    landscape() {
        window.webkit.messageHandlers['nativeCommandHandler'].postMessage({name:'landscape',data: null });
    },
    
    portrait() {
        window.webkit.messageHandlers['nativeCommandHandler'].postMessage({name:'portrait',data: null });
    }
};
